## gle-graphics 4.3.3

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)
cmake_policy(SET CMP0091 NEW) 	# windows static runtimes selection
cmake_policy(SET CMP0074 NEW)	# uses <PackageName>_ROOT variables.
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
SET( CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")	# minimum supported by apple

project (gle VERSION 4.3.3)

add_compile_definitions(GLEVN="${PROJECT_VERSION}")
set( CMAKE_DEBUG_POSTFIX  "d")
#
# -- Windows option for static runtimes
#
if(WIN32)
	#
	# -- Windows option for runtime library - assume DLL /MD unless USE_STATIC_RUNTIME=ON then use static /MT
	#
	set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
	if(DEFINED USE_STATIC_RUNTIME AND USE_STATIC_RUNTIME)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
		# tag CPACK_SYSTEM_NAME with "s" to denote static runtime - must rebuild the whole name as there is no way to add a tag
		set(CPACK_SYSTEM_NAME "win64s")
		if(${CMAKE_GENERATOR_PLATFORM} STREQUAL "Win32")
			set(CPACK_SYSTEM_NAME "win32s")
		endif()
	endif()
endif()
#
# -- cpack information  (need more here for NSIS and others - manual and sample gle files)
#
set(CPACK_PACKAGE_VENDOR "GLE")
set(CPACK_VERBATIM_VARIABLES true)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "GLE Graphics Programming Language")
#set(CPACK_PACKAGE_DESCRIPTION_FILE )
#set(CPACK_RESOURCE_FILE_WELCOME )
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../doc/LICENSE.txt")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/../doc/README.txt")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "GLE")
#
# - NSIS specifc settings
#
set(CPACK_NSIS_COMPRESSOR "lzma")
set(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}/gui/images\\gle.ico")
set(CPACK_NSIS_MUI_UNIICON "${CMAKE_CURRENT_SOURCE_DIR}/gui/images\\gle.ico")
set(CPACK_NSIS_MUI_HEADERIMAGE "${CMAKE_CURRENT_SOURCE_DIR}/../graphics\\nsis_banner_image.bmp")
set(CPACK_NSIS_MUI_WELCOMEFINISHPAGE_BITMAP "${CMAKE_CURRENT_SOURCE_DIR}/../graphics\\nsis_welcome_image.bmp")
set(CPACK_NSIS_WELCOME_TITLE "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_BRANDING_TEXT "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_DISPLAY_NAME "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL OFF)
set(CPACK_NSIS_MODIFY_PATH ON)
set(CPACK_PACKAGE_EXECUTABLES 	"qgle" "GLE Previewer"  )
set(CPACK_NSIS_MENU_LINKS  		"doc/gle-manual.pdf" "GLE Mamual"
	"https://glx.sourceforge.io" "GLE Web Site"
	"https://github.com/vlabella/GLE" "GLE GitHub page"
)
  
# extra commands include finddeps and setting file associations
set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
	Exec \"$INSTDIR\\bin\\qgle.exe -finddeps '$INSTDIR\\glerc.old'\"
	WriteRegStr HKCR '.gle' '' 'GLEFile'
  	WriteRegStr HKCR 'GLEFile' '' 'GLE Script'
  	WriteRegStr HKCR 'GLEFile\\DefaultIcon' '' '$INSTDIR\\bin\\qgle.exe,0'
  	WriteRegStr HKCR 'GLEFile\\shell\\open\\command' '' '$INSTDIR\\bin\\qgle.exe \"%1\"'
  	WriteRegStr HKCR 'GLEFile\\shell\\edit' '' 'Edit GLE Script'
  	WriteRegStr HKCR 'GLEFile\\shell\\edit\\command' '' '$INSTDIR\\bin\\qgle.exe \"%1\"'
  	System::Call 'Shell32::SHChangeNotify(i 0x8000000, i 0, i 0, i 0)'
")
set (CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "
	DeleteRegKey HKCR '.gle'
    DeleteRegKey HKCR 'GLEFile'
")
#
# -- wix specific settings unused no .msi generated
# dont change these GUIDs once generated
#set(CPACK_WIX_UPGRADE_GUID "" )
#set(CPACK_WIX_PRODUCT_GUID "" )
#set(CPACK_WIX_PRODUCT_ICON "")
#
# -- DragNDrop MacOS dmg settings
#
set(CPACK_DMG_FORMAT "UDBZ")

include(CPack)
#
# -- external libraries user can pass ***_ROOT to modify search location
#
SET(Boost_USE_STATIC_LIBS ON)
find_package(Boost )
find_package(ZLIB )
find_package(JPEG )
find_package(TIFF )
# note findPNG calls findZLIB
find_package(PNG )
# find debug if it exists for multi config generators only
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(PNG_DEBUG NAMES pngd libpngd PATHS ${PNG_ROOT} PATH_SUFFIXES lib )
	if(NOT ${PNG_DEBUG} STREQUAL "PNG_DEBUG-NOTFOUND" )
		list(INSERT PNG_LIBRARIES 0 "optimized")
		list(APPEND PNG_LIBRARIES "debug")
		list(APPEND PNG_LIBRARIES ${PNG_DEBUG})
	endif()
endif()
#find_package(Cairo )
#find_package(Pixman )
#
# -- cairo library - cmake does not supply findCAIRO.cmake
#	
set(CAIRO_FOUND )
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(CAIRO_RELEASE NAMES cairo PATHS ${CAIRO_ROOT} PATH_SUFFIXES lib REQUIRED )
	string(COMPARE NOTEQUAL "${CAIRO_RELEASE}" "CAIRO_RELEASE-NOTFOUND" CAIRO_FOUND)
	find_library(CAIRO_DEBUG NAMES cairod PATHS ${CAIRO_ROOT} PATH_SUFFIXES lib )
	set(HAS_DEBUG )
	string(COMPARE NOTEQUAL "${CAIRO_DEBUG}" "CAIRO_DEBUG-NOTFOUND" HAS_DEBUG)
	if(HAS_DEBUG)
		list(APPEND CAIRO_LIBRARIES "optimized")
		list(APPEND CAIRO_LIBRARIES ${CAIRO_RELEASE})
		list(APPEND CAIRO_LIBRARIES "debug")
		list(APPEND CAIRO_LIBRARIES ${CAIRO_DEBUG})
	else()
		list(APPEND CAIRO_LIBRARIES ${CAIRO_RELEASE})
	endif()
else()
	find_library(CAIRO_LIBRARIES NAMES cairo cairod PATHS ${CAIRO_ROOT} PATH_SUFFIXES lib REQUIRED)
	string(COMPARE NOTEQUAL "${CAIRO_LIBRARIES}" "CAIRO_LIBRARIES-NOTFOUND" CAIRO_FOUND)
endif()
find_path(CAIRO_INCLUDE_DIRS cairo.h PATHS ${CAIRO_ROOT} PATH_SUFFIXES include REQUIRED)
if(CAIRO_FOUND)
	message("-- Found CAIRO: " ${CAIRO_LIBRARIES} )
endif()
#
# -- pixman library - cmake does not supply findPIXMAN.cmake
#	
set(PIXMAN_FOUND )
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(PIXMAN_RELEASE NAMES pixman PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib REQUIRED)
	string(COMPARE NOTEQUAL "${PIXMAN_RELEASE}" "PIXMAN_RELEASE-NOTFOUND" PIXMAN_FOUND)
	find_library(PIXMAN_DEBUG NAMES pixmand PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib )
	set(HAS_DEBUG )
	string(COMPARE NOTEQUAL "${PIXMAN_DEBUG}" "PIXMAN_DEBUG-NOTFOUND" HAS_DEBUG)
	if(HAS_DEBUG)
		list(APPEND PIXMAN_LIBRARIES "optimized")
		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
		list(APPEND PIXMAN_LIBRARIES "debug")
		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_DEBUG})
	else()
		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
	endif()
else()
	find_library(PIXMAN_LIBRARIES NAMES pixman pixmand PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib REQUIRED)
	string(COMPARE NOTEQUAL "${PIXMAN_LIBRARIES}" "PIXMAN_LIBRARIES-NOTFOUND" PIXMAN_FOUND)
endif()
find_path(PIXMAN_INCLUDE_DIRS pixman.h PATHS ${PIXMAN_ROOT} PATH_SUFFIXES include REQUIRED)
if(PIXMAN_FOUND)
	message("-- Found PIXMAN: " ${PIXMAN_LIBRARIES} )
endif()
#
# -- GHOSTscript or GHOSTPDL include directory only since gle links to installed version at runtime
#
find_path(GDIR1 iapi.h PATHS ${GHOSTPDL_ROOT} PATH_SUFFIXES psi base devices )
list(APPEND GHOSTPDL_INCLUDE_DIRS ${GDIR1} )
find_path(GDIR2 gdevdsp.h PATHS ${GHOSTPDL_ROOT} PATH_SUFFIXES psi base devices )
list(APPEND GHOSTPDL_INCLUDE_DIRS ${GDIR2} )
find_path(GDIR3 gserrors.h PATHS ${GHOSTPDL_ROOT} PATH_SUFFIXES psi base devices )
list(APPEND GHOSTPDL_INCLUDE_DIRS ${GDIR3} )

include_directories(
	${ZLIB_INCLUDE_DIRS}
	${JPEG_INCLUDE_DIRS}
	${Boost_INCLUDE_DIRS}
	${TIFF_INCLUDE_DIRS}
	${PNG_INCLUDE_DIRS}
	${CAIRO_INCLUDE_DIRS}
	${PIXMAN_INCLUDE_DIRS}
	${GHOSTPDL_INCLUDE_DIRS}
)
#
# -- compile time definitions
#
if(APPLE)
	# GLE specific definitions
	add_compile_definitions(
		__MAC__
		__OSX__
		__MACOS__
		HAVE_CONFIG_H
		HAVE_CAIRO
		HAVE_LIBZ
		HAVE_LIBPNG
		HAVE_LIBJPEG
		HAVE_LIBTIFF
		HAVE_EXTRA_FONTS
		HAVE_LIBGLU_H
	)
	CHECK_INCLUDE_FILE(assert.h    HAVE_ASSERT_H)
	CHECK_INCLUDE_FILE(dlfcn.h     HAVE_DLFCN_H)
	CHECK_INCLUDE_FILE(fcntl.h     HAVE_FCNTL_H)
	CHECK_INCLUDE_FILE(inttypes.h  HAVE_INTTYPES_H)
	CHECK_INCLUDE_FILE(io.h        HAVE_IO_H)
	CHECK_INCLUDE_FILE(search.h    HAVE_SEARCH_H)
	CHECK_INCLUDE_FILE(stdint.h    HAVE_STDINT_H)
	CHECK_INCLUDE_FILE(stdlib.h    HAVE_STDLIB_H)
	CHECK_INCLUDE_FILE(stdlib.h    STDC_HEADERS)
	CHECK_INCLUDE_FILE(stddef.h    STDC_HEADERS)
	CHECK_INCLUDE_FILE(stddef.h    HAVE_STDDEF_H)
	CHECK_INCLUDE_FILE(string.h    HAVE_STRING_H)
	CHECK_INCLUDE_FILE(strings.h   HAVE_STRINGS_H)
	CHECK_INCLUDE_FILE_CXX(cstring     HAVE_CSTRING)
	CHECK_INCLUDE_FILE(sys/time.h  HAVE_SYS_TIME_H)
	CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
	CHECK_INCLUDE_FILE(sys/wait.h HAVE_SYS_WAIT_H)
	CHECK_INCLUDE_FILE(sys/stat.h  HAVE_SYS_STAT_H)
	CHECK_INCLUDE_FILE(unistd.h    HAVE_UNISTD_H)
	CHECK_INCLUDE_FILE(sys/socket.h HAVE_SOCKETS)
	#set(CONFIG_H_SOURCE "config.h.cmake")
#	add_compile_options(-framework OpenGL)
	add_Compile_options(-std=c++11)
	add_compile_options(-Wno-c++11-compat-deprecated-writable-strings)
	add_compile_options(-Wno-unsequenced)
	add_compile_options(-Wno-macro-redefined)
	add_compile_options(-Wno-deprecated-register)
	add_compile_options(-Wno-deprecated-declarations)
	add_compile_definitions(BOOST_MATH_DISABLE_DEPRECATED_03_WARNING)
endif()
if(UNIX AND NOT APPLE)
	add_compile_definitions(
		__LINUX__
		UNIX
		__UNIX__
		HAVE_CONFIG_H
		HAVE_CAIRO
		HAVE_LIBZ
		HAVE_LIBPNG
		HAVE_LIBJPEG
		HAVE_LIBTIFF
		HAVE_EXTRA_FONTS
		HAVE_LIBGLU_H
	)
	CHECK_INCLUDE_FILE(assert.h    HAVE_ASSERT_H)
	CHECK_INCLUDE_FILE(dlfcn.h     HAVE_DLFCN_H)
	CHECK_INCLUDE_FILE(fcntl.h     HAVE_FCNTL_H)
	CHECK_INCLUDE_FILE(inttypes.h  HAVE_INTTYPES_H)
	CHECK_INCLUDE_FILE(io.h        HAVE_IO_H)
	CHECK_INCLUDE_FILE(search.h    HAVE_SEARCH_H)
	CHECK_INCLUDE_FILE(stdint.h    HAVE_STDINT_H)
	CHECK_INCLUDE_FILE(stdlib.h    HAVE_STDLIB_H)
	CHECK_INCLUDE_FILE(stdlib.h    STDC_HEADERS)
	CHECK_INCLUDE_FILE(stddef.h    STDC_HEADERS)
	CHECK_INCLUDE_FILE(stddef.h    HAVE_STDDEF_H)
	CHECK_INCLUDE_FILE(string.h    HAVE_STRING_H)
	CHECK_INCLUDE_FILE(strings.h   HAVE_STRINGS_H)
	CHECK_INCLUDE_FILE_CXX(cstring     HAVE_CSTRING)
	CHECK_INCLUDE_FILE(sys/time.h  HAVE_SYS_TIME_H)
	CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
	CHECK_INCLUDE_FILE(sys/stat.h  HAVE_SYS_STAT_H)
	CHECK_INCLUDE_FILE(sys/wait.h HAVE_SYS_WAIT_H)
	CHECK_INCLUDE_FILE(unistd.h    HAVE_UNISTD_H)
	CHECK_INCLUDE_FILE(sys/socket.h HAVE_SOCKETS)
	#set(CONFIG_H_SOURCE "config.h.cmake")
	add_compile_options(-Wno-deprecated)
	add_compile_options(-Wno-write-strings)
	add_compile_options(-Wno-stringop-overflow)
	add_compile_options(-Wno-deprecated-declarations)
	add_compile_options(-fpermissive)
	add_compile_options(-fPIC)
	#add_compile_options(-no-pie)
endif()
if(WIN32)
	# GLE specific definitions
	add_compile_definitions(
		__WIN32__
		__NOCYGWIN__
		NOMINMAX
		HAVE_CONFIG_H
		HAVE_CAIRO
		HAVE_LIBZ
		HAVE_LIBPNG
		HAVE_LIBJPEG
		HAVE_LIBTIFF
		HAVE_EXTRA_FONTS
		CAIRO_WIN32_STATIC_BUILD
		HAVE_SOCKETS
		HAVE_LIBGLU_H
	)
	CHECK_INCLUDE_FILE(assert.h    HAVE_ASSERT_H)
	CHECK_INCLUDE_FILE(dlfcn.h     HAVE_DLFCN_H)
	CHECK_INCLUDE_FILE(fcntl.h     HAVE_FCNTL_H)
	CHECK_INCLUDE_FILE(inttypes.h  HAVE_INTTYPES_H)
	CHECK_INCLUDE_FILE(io.h        HAVE_IO_H)
	CHECK_INCLUDE_FILE(search.h    HAVE_SEARCH_H)
	CHECK_INCLUDE_FILE(stdint.h    HAVE_STDINT_H)
	CHECK_INCLUDE_FILE(stdlib.h    HAVE_STDLIB_H)
	CHECK_INCLUDE_FILE(stdlib.h    STDC_HEADERS)
	CHECK_INCLUDE_FILE(stddef.h    STDC_HEADERS)
	CHECK_INCLUDE_FILE(stddef.h    HAVE_STDDEF_H)
	CHECK_INCLUDE_FILE(string.h    HAVE_STRING_H)
	CHECK_INCLUDE_FILE(strings.h   HAVE_STRINGS_H)
	CHECK_INCLUDE_FILE_CXX(cstring  HAVE_CSTRING)
	CHECK_INCLUDE_FILE(sys/time.h  HAVE_SYS_TIME_H)
	CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
	CHECK_INCLUDE_FILE(sys/stat.h  HAVE_SYS_STAT_H)
	CHECK_INCLUDE_FILE(sys/wait.h HAVE_SYS_WAIT_H)
	CHECK_INCLUDE_FILE(unistd.h    HAVE_UNISTD_H)
	# should comment out and modify code so these warnings are not thrown
	add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
	add_compile_definitions(_SILENCE_STDEXT_HASH_DEPRECATION_WARNINGS)
	add_compile_options(/wd4290)
	add_compile_options(/wd4244)
	add_compile_options(/wd4099)
	add_compile_options(/wd4305) # double to float truncation
	add_compile_options(/wd4805) # = unsafe mix of type in and type bool
	add_compile_options(/wd4804) # < unsafe use of type bool

=== src/TeX/CMakeLists.txt ===
#
# -- generate inittex.ini from init.tex
#
# set(OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/../gle)

# # crazy specializaton here
# if(WIN32)
# set(GLE ${OUTPUT_DIR}$<$<PLATFORM_ID:Windows>:$<IF:$<CONFIG:debug>,/Debug,/Release>>/gle$<$<CONFIG:Debug>:d> )

# add_custom_command(
# 	OUTPUT ${OUTPUT_DIR}/inittex.ini
# 	DEPENDS init.tex
# 	COMMAND ${CMAKE_COMMAND} -E make-directory ${OUTPUT_DIR}/bin
# 	COMMAND ${CMAKE_COMMAND} -E create_symlink ${OUTPUT_DIR}/gle ${OUTPUT_DIR}/bin/gle
# 	COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/init.tex ${OUTPUT_DIR}/init.tex
# 	COMMAND ${GLE} -mkinittex
# 	WORKING_DIRECTORY ${OUTPUT_DIR}/bin
# 	COMMENT "Generating inittex.ini from init.tex"
# )
# else()
# set(GLE ${OUTPUT_DIR}$<$<PLATFORM_ID:Windows>:$<IF:$<CONFIG:debug>,/Debug,/Release>>/gle$<$<CONFIG:Debug>:d> )

# add_custom_command(
# 	OUTPUT ${OUTPUT_DIR}/inittex.ini
# 	DEPENDS init.tex
# 	COMMAND ${CMAKE_COMMAND} -E make-directory ${OUTPUT_DIR}/bin
# 	COMMAND ${CMAKE_COMMAND} -E create_symlink ${OUTPUT_DIR}/gle ${OUTPUT_DIR}/bin/gle
# 	COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/init.tex ${OUTPUT_DIR}/init.tex
# 	COMMAND ${GLE} -mkinittex
# 	WORKING_DIRECTORY ${OUTPUT_DIR}/bin
# 	COMMENT "Generating inittex.ini from init.tex"
# )


# endif()
# add_custom_target(inittex ALL DEPENDS 
# 	${OUTPUT_DIR}/inittex.ini
# 	gle
# )

# install(FILES 
# 	${OUTPUT_DIR}/inittex.ini 
# 	${OUTPUT_DIR}/init.tex
# 	CONFIGURATIONS Release Debug
# 	DESTINATION . 
# )

install(FILES 
	init.tex
 	CONFIGURATIONS Release Debug
 	DESTINATION . 
)
# make the inittex.ini in the install folder
install(CODE "execute_process(COMMAND ${CMAKE_INSTALL_PREFIX}/bin/gle$<$<CONFIG:Debug>:d> -mkinittex)")
# explicity install inittex.ini for cpack even though its created in this directory
# from gle -mkinittex command above
install(FILES 
	${CMAKE_INSTALL_PREFIX}/inittex.ini
 	CONFIGURATIONS Release Debug
 	DESTINATION . 
)

=== src/gle/CMakeLists.txt ===

set(GLE_SOURCES
	bitmap/img2ps.cpp
	bitmap/lzwencode.cpp
	bitmap/glegif.cpp
	bitmap/glejpeg.cpp
	bitmap/gletiff.cpp
	bitmap/glepng.cpp
	bitmap/ascii85.cpp
	letzfitz/let.cpp
	letzfitz/fit.cpp
	letzfitz/ffit.cpp
	surface/gsurface.cpp
	surface/hide.cpp
	surface/fcontour.cpp
	surface/ffitcontour.cpp
	surface/gcontour.cpp
	tokens/Tokenizer.cpp
	tokens/StringKeyHash.cpp
	tokens/BinIO.cpp
	axis.cpp
	b_tab.cpp
	b_text.cpp
	begin.cpp
	core.cpp
	curve.cpp
	color.cpp
	drawit.cpp
	eval.cpp
	fitbez.cpp
	fitcf.cpp
	fn.cpp
	font.cpp
	general.cpp
	op_def.cpp
	gprint.cpp
	graph.cpp
	graph2.cpp
	key.cpp
	keyword.cpp
	leastsq.cpp
	memory.cpp
	mychar.cpp
	pass.cpp
	polish.cpp
	run.cpp
	savgol.cpp
	sub.cpp
	tex.cpp
	token.cpp
	var.cpp
	cutils.cpp
	texinterface.cpp
	d_ps.cpp
	d_svg.cpp
	d_x.cpp
	d_dummy.cpp
	d_cairo.cpp
	config.cpp
	numberformat.cpp
	glearray.cpp
	cmdline.cpp
	gle-block.cpp
	gle-sourcefile.cpp
	gle-interface.cpp
	gle-base.cpp
	gle-datatype.cpp
	gle-poppler.cpp
	builtin-double.cpp
	cutils.cpp
	file_io.cpp
	specialfunctions.cpp
)

set( GLEBTOOL_SOURCES
	cutils.cpp 
	file_io.cpp 
	glebtool.cpp
)

add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/gle_cpp_lib.cpp
 	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gle.cpp
 	COMMAND ${CMAKE_COMMAND} -E copy gle.cpp gle_cpp_lib.cpp
  	COMMENT "Generating gle_cpp_lib.cpp from gle.cpp"
  	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/glerc
 	COMMAND ${CMAKE_COMMAND} -E echo begin config gle > ${CMAKE_CURRENT_BINARY_DIR}/glerc
 	COMMAND ${CMAKE_COMMAND} -E echo current = ${PROJECT_VERSION} >> ${CMAKE_CURRENT_BINARY_DIR}/glerc
 	COMMAND ${CMAKE_COMMAND} -E echo end config >> ${CMAKE_CURRENT_BINARY_DIR}/glerc
  	COMMENT "Generating glerc in ${CMAKE_CURRENT_BINARY_DIR}"
  	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_library(gle_common OBJECT ${GLE_SOURCES})
add_executable( gle $<TARGET_OBJECTS:gle_common> gle.cpp )
add_library( libgle-graphics_s STATIC $<TARGET_OBJECTS:gle_common> gle_cpp_lib.cpp )
add_library( libgle-graphics SHARED $<TARGET_OBJECTS:gle_common> gle_cpp_lib.cpp )
add_custom_target( glerc_file ALL DEPENDS glerc )
set_source_files_properties( gle_cpp_lib.cpp PROPERTIES COMPILE_FLAGS -DHAVE_LIBGLE)

set_target_properties(gle PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX}) 
set_target_properties(libgle-graphics_s PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX}) 
set_target_properties(libgle-graphics PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX}) 

if(UNIX AND NOT APPLE)
	target_link_options(libgle-graphics PUBLIC -fPIC)
	target_link_options(libgle-graphics_s PUBLIC -fPIC)
endif()


target_link_libraries ( gle LINK_PUBLIC 
	${ZLIB_LIBRARIES}
	${JPEG_LIBRARIES}
	${TIFF_LIBRARIES}
	${PNG_LIBRARIES}
	${CAIRO_LIBRARIES}
	${PIXMAN_LIBRARIES}
	)

target_link_libraries ( libgle-graphics LINK_PUBLIC 
	${ZLIB_LIBRARIES}
	${JPEG_LIBRARIES}
	${TIFF_LIBRARIES}
	${PNG_LIBRARIES}
	${CAIRO_LIBRARIES}
	${PIXMAN_LIBRARIES}
	)

if(WIN32)
	target_link_libraries ( libgle-graphics LINK_PUBLIC 
		opengl32.lib
		wsock32.lib
		Ws2_32.lib 
		msimg32.lib
		)
	target_link_libraries( gle LINK_PUBLIC 
		opengl32.lib
		wsock32.lib
		Ws2_32.lib 
		msimg32.lib
		)
endif()
if(APPLE)
	target_link_libraries ( libgle-graphics LINK_PUBLIC 
		lzma
	)
	target_link_libraries ( gle LINK_PUBLIC 
		lzma
	)
endif()

install(TARGETS gle
		CONFIGURATIONS Release Debug
		RUNTIME )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/glerc
		CONFIGURATIONS Release Debug
		DESTINATION . )

=== src/gui/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
#
# -- Qt5  set Qt5_DIR
#
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

find_package(Qt5 COMPONENTS 
	Widgets
	Network
	DBus
	Gui
	OpenGL
	REQUIRED)

add_executable(qgle WIN32 MACOSX_BUNDLE
	3dviewer.cpp
	about.cpp
	amove.cpp
	arc.cpp
	circle.cpp
	colourbutton.cpp
	colourpicker.cpp
	component.cpp
	consolewindow.cpp
	dialogues.cpp
#    downloader.cpp
	drawingobject.cpp
	ellipse.cpp
	fileinfo.cpp
	gledrawing.cpp
	grid.cpp
	line.cpp
	main.cpp
	mainwindow.cpp
	newfile.cpp
	objectblocks.cpp
	polararray.cpp
	propertyeditor.cpp
	propertymodel.cpp
	qgle_statics.cpp
	qgs.cpp
	qgslibloader.cpp
	serverthread.cpp
	settings.cpp
	settings_dialogue.cpp
	snapline.cpp
	text.cpp
	variantdelegate.cpp
	$<$<PLATFORM_ID:Darwin>:macspecific.cpp>
	qgle.qrc
	$<$<PLATFORM_ID:Windows>:qgle.rc>
)
# no jpeg as its contianed in Qt
target_link_libraries ( qgle LINK_PUBLIC 
	${ZLIB_LIBRARIES}
	${TIFF_LIBRARIES}
	${PNG_LIBRARIES}
	${PIXMAN_LIBRARIES}
	libgle-graphics_s
	Qt::Core
	Qt::Gui
	Qt::Network
	Qt::Widgets
	Qt::OpenGL
	${CAIRO_LIBRARIES}
	)

if(UNIX AND NOT APPLE)
 	target_link_libraries ( qgle LINK_PUBLIC 
 		glut
 		GLU
 		GL 
# 		Qt5::QWaylandIntegrationPlugin
 	)
 	target_link_options(qgle PUBLIC -no-pie)
	qt_import_plugins( qgle
  		INCLUDE_BY_TYPE platforms
	)
endif()

if(WIN32)
	target_link_libraries(qgle LINK_PUBLIC 
	 msimg32.lib 
	 opengl32.lib
	 glu32.lib
	)
endif()
if(APPLE)
	#openGL is depricated on OSX starting 10.9 this silences the warning
	add_compile_definitions(Q_OS_APPLE)
	add_compile_options(-Wno-deprecated-declarations)
	target_link_libraries ( qgle LINK_PUBLIC 
	lzma
	"-framework AppKit"
	"-framework GSS"
	"-framework IOKit"
	"-framework Security"
    "-framework Cocoa"
    "-framework OpenGL"
    "-framework SystemConfiguration"
    "-framework Carbon"
	)
endif()
set_target_properties(qgle PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX}) 

install(TARGETS qgle RUNTIME BUNDLE DESTINATION bin )

## gle-graphics 4.2.3b

=== debian/changelog ===
gle-graphics (4.2.3b-2ubuntu1) precise; urgency=low

  * Backport upstream patch to build against qt4.8 (LP: #935114)

 -- Andreas Moog <amoog@ubuntu.com>  Fri, 24 Feb 2012 19:41:20 +0100

gle-graphics (4.2.3b-2) unstable; urgency=low

  * configure with-scripts=no
  * remove glebtool only when it exists
  * do not compress LICENSE.txt as it is read by qgle
  * let qgle search for /usr/lib/libgs.so.9 before any other libgs

 -- Christian T. Steigies <cts@debian.org>  Mon, 07 Nov 2011 22:42:59 +0100

gle-graphics (4.2.3b-1) unstable; urgency=low

  * new upstream version
  * switch from cdbs to debhelper 8
  * update copyright file
  * do no rely on proc on non-linux systems (closes: #644588)
  * do not ship glebtool, which is a helper used only during build
  * add libqt4-opengl-dev to build-depends

 -- Christian T. Steigies <cts@debian.org>  Thu, 20 Oct 2011 22:15:27 +0200

gle-graphics (4.2.2-6) unstable; urgency=low

  * define PATH_MAX to fix building on gnu-hurd

 -- Christian T. Steigies <cts@debian.org>  Fri, 07 Oct 2011 21:20:44 +0200

gle-graphics (4.2.2-5) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * qgle: link with -ldl for all unix targets (closes: #554556)
  * recommend libgs9 instead of libgs8
  * Updated Standards-Version to 3.9.2 (no changes)
  * do not ignore make clean errors

 -- Christian T. Steigies <cts@debian.org>  Thu, 06 Oct 2011 23:10:58 +0200

gle-graphics (4.2.2-4) unstable; urgency=low

  * add libtool and pkg-config to build-depends

 -- Christian T. Steigies <cts@debian.org>  Tue, 06 Apr 2010 22:52:09 +0200

gle-graphics (4.2.2-3) unstable; urgency=low

  * run "autoreconf -vfi" as pre-configure action instead of 
    "aclocal && autoconf" as configure action (closes: #571296)
  * remove autogenerated aclocal.m4 and configure in clean target
  
 -- Christian T. Steigies <cts@debian.org>  Mon, 05 Apr 2010 21:36:40 +0200

gle-graphics (4.2.2-2) unstable; urgency=low

  * upload to unstable
  * Updated Standards-Version to 3.8.4 (no changes)

 -- Christian T. Steigies <cts@debian.org>  Wed, 24 Feb 2010 23:21:37 +0100

gle-graphics (4.2.2-1) experimental; urgency=low

  * new upstream version
  * 001-kfreebsd-support patch is included upstream
  * configure --with-rpath=no

 -- Christian T. Steigies <cts@debian.org>  Wed, 20 Jan 2010 22:59:32 +0100

gle-graphics (4.2.1-2) experimental; urgency=low

  * add patch to allow building on kfreebsd
  * Updated Standards-Version to 3.8.3 (no changes)

 -- Christian T. Steigies <cts@debian.org>  Wed, 09 Sep 2009 00:56:21 +0200

gle-graphics (4.2.1-1) experimental; urgency=low

  * new upstream version
  * added automake and ghostscript to Build-Depends

 -- Christian T. Steigies <cts@debian.org>  Sat, 05 Sep 2009 22:33:51 +0200

gle-graphics (4.2.0-1) experimental; urgency=low

  * new upstream version
  * rename package to gle-graphics

 -- Christian T. Steigies <cts@debian.org>  Fri, 17 Apr 2009 00:36:23 +0200

glx (4.2.0-1) experimental; urgency=low

  * new upstream version
  * Updated Standards-Version to 3.8.0 (no changes)
  * do not ship LICENSE.txt, this is included in debian/copyright
  * addeded simple man and qgle manpages
  * build and ship gle-manual.pdf

 -- Christian T. Steigies <cts@debian.org>  Mon, 13 Apr 2009 14:04:59 +0200

glx (4.1.1) experimental; urgency=low

  * new upstream version

 -- Christian T. Steigies <cts@debian.org>  Tue, 26 Feb 2008 23:58:04 +0100

glx (4.1.0-rc2-1) experimental; urgency=low

  * new upstream version

 -- Christian T. Steigies <cts@debian.org>  Thu, 22 Nov 2007 22:52:11 +0100

glx (4.1.0-rc1-1) experimental; urgency=low

  * new upstream version

 -- Christian T. Steigies <cts@debian.org>  Thu,  4 Oct 2007 00:46:10 +0200

glx (4.0.12-1) experimental; urgency=low

  * new upstream version
  * switch to cdbs, build from upstream "tarball"

 -- Christian T. Steigies <cts@debian.org>  Wed,  3 Oct 2007 12:08:52 +0200

glx (4.0.7-1) unstable; urgency=low

  * Initial Release.

 -- Christian T. Steigies <cts@debian.org>  Sat,  8 Jan 2005 11:31:38 +0100

=== debian/control ===
Source: gle-graphics
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christian T. Steigies <cts@debian.org>
Build-Depends: debhelper (>= 8.0.0), libtiff-dev, libboost-dev, libqt4-dev, libqt4-opengl-dev, libjpeg-dev, libpng-dev, ncurses-dev, texlive, texlive-latex-extra, automake, ghostscript, libtool, pkg-config
Standards-Version: 3.9.2

Package: gle-graphics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgs9
Description: Interactive Graphics Language Editor
 GLE  is  a  high  quality  graphics  package for scientists,
 combining  a  user  friendly  interface with a full range of
 facilities    for   producing  publication  quality  graphs,
 diagrams, posters and slides.
 .
 GLE  provides LaTeX quality fonts together with a flexible
 graphics  module  which  allows  the  user  to  specify  any
 feature  of a graph (down to the line width of the subticks,
 for example)
 .
 Complex  pictures can be drawn with user defined subroutines
 and simple looping structures.
 .
 Current  device  drivers support DECWINDOWS, REGIS, TEK4010,
 all  PC  graphics  cards,  VT100s,  HP-Plotters,  PostScript
 Printers, EPSON Printers and LaserJet Printers.
 .
 GLE  runs  on  both  VAXes and PCs, giving an identical user
 interface on both platforms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	make	
	make doc

override_dh_auto_clean:
	[ ! -f Makefile ] || make distclean
# remove files which are updated by autoreconf:
	-rm aclocal.m4 configure

override_dh_auto_configure:
	-autoreconf -vfi
	./configure --docdir=/usr/share/doc/gle-graphics/ --with-rpath=no --with-scripts=no

override_dh_auto_install:
	dh_auto_install
	cp debian/qgle.1 debian/gle-graphics/usr/share/man/man1/
	cp debian/manip.1 debian/gle-graphics/usr/share/man/man1/
# do not ship helper that is only used during build
	[ -f debian/gle-graphics/usr/bin/glebtool ] || rm debian/gle-graphics/usr/bin/glebtool

# do not compress LICENSE.txt as it needs to be read by qgle
override_dh_compress:
	dh_compress -X usr/share/doc/gle-graphics/LICENSE.txt

## gle-graphics 4.2.4

=== debian/changelog ===
gle-graphics (4.2.4-1) unstable; urgency=low

  * new upstream version

 -- Christian T. Steigies <cts@debian.org>  Wed, 11 Jan 2012 22:59:48 +0100

gle-graphics (4.2.3b~rc1-1) experimental; urgency=low

  * new upstream version, includes libgs9 and hurd patches
  * enable hardening with hardening-wrapper
  * fix typos in binaries
  * add Homepage field
  * register gle-manual with doc-base

 -- Christian T. Steigies <cts@debian.org>  Sat, 12 Nov 2011 13:37:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: gle-graphics
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christian T. Steigies <cts@debian.org>
-Build-Depends: debhelper (>= 8.0.0), libtiff-dev, libboost-dev, libqt4-dev, libqt4-opengl-dev, libjpeg-dev, libpng-dev, ncurses-dev, texlive, texlive-latex-extra, automake, ghostscript, libtool, pkg-config
+Maintainer: Christian T. Steigies <cts@debian.org>
+Build-Depends: debhelper (>= 8.0.0), libtiff-dev, libboost-dev, libqt4-dev, libqt4-opengl-dev, libjpeg-dev, libpng-dev, ncurses-dev, texlive, texlive-latex-extra, automake, ghostscript, libtool, pkg-config, hardening-wrapper
 Standards-Version: 3.9.2
+Homepage: http://glx.sf.net
 
 Package: gle-graphics
 Architecture: any

## gle-graphics 4.2.4c

=== debian/changelog ===
gle-graphics (4.2.4c-5) unstable; urgency=low

  * fix building on hurd-i386 with workaround from #578320

 -- Christian T. Steigies <cts@debian.org>  Sun, 30 Sep 2012 23:58:58 +0200

gle-graphics (4.2.4c-4) unstable; urgency=low

  * rewrite package description (closes: #685822)

 -- Christian T. Steigies <cts@debian.org>  Wed, 26 Sep 2012 23:07:27 +0200

gle-graphics (4.2.4c-3) unstable; urgency=low

  * pass --build $(DEB_HOST_GNU_TYPE) to configure
  * do not set DEB_BUILD_HARDENING on sparc to fix building on the buildd

 -- Christian T. Steigies <cts@debian.org>  Wed, 27 Jun 2012 21:50:27 +0200

gle-graphics (4.2.4c-2) unstable; urgency=low

  * add libpoppler-glib-dev and libcairo-dev to Build-Depends
  * build package on smetana.debian.org to show that it does not FTBFS 
    on sparc (closes: #669161)

 -- Christian T. Steigies <cts@debian.org>  Tue, 15 May 2012 23:56:53 +0200

gle-graphics (4.2.4c-1) unstable; urgency=low

  * new upstream version (closes: #662710, #667183)
  * updated Standards-Version to 3.9.3 (no changes)
  
 -- Christian T. Steigies <cts@debian.org>  Fri, 11 May 2012 00:01:36 +0200

=== debian/control ===
Source: gle-graphics
Section: graphics
Priority: optional
Maintainer: Christian T. Steigies <cts@debian.org>
Build-Depends: automake,
               debhelper (>= 8.0.0),
               ghostscript,
               hardening-wrapper,
               libboost-dev,
               libcairo-dev,
               libjpeg-dev,
               libpng-dev,
               libpoppler-glib-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libtiff-dev,
               libtool,
               ncurses-dev,
               pkg-config,
               texlive,
               texlive-latex-extra
Standards-Version: 3.9.3
Homepage: http://glx.sf.net

Package: gle-graphics
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libgs9
Description: Graphics Layout Engine
 GLE is a graphics scripting language designed for creating publication
 quality figures such as charts, plots, graphs, and diagrams. It
 supports various chart types (including function plot, histogram, bar
 chart, scatter plot, contour plot, color map, and surface plot) through
 a simple but flexible set of graphing commands; more complex output can
 be created by relying on its scripting language, which is full featured
 with subroutines, variables, and logic control.
 .
 GLE relies on LaTeX for text output and supports mathematical formulae
 in graphs and figures. Output formats include (E)PS, PDF, JPEG, and PNG.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_HARDENING=1

# fix build problems on the sparc buildd
ifeq ($(DEB_HOST_ARCH),sparc)
export DEB_BUILD_HARDENING=0
#export MALLOC_CHECK_=0
endif

# fix build problems on the hurd
ifeq ($(DEB_HOST_ARCH),hurd-i386)
CONFIGURE_LIBS = LIBS="-Wl,--no-as-needed -Wl,-lpthread -Wl,--as-needed"
endif

%:
	dh $@ 

override_dh_auto_build:
	make	
	make doc

override_dh_auto_clean:
	[ ! -f Makefile ] || make distclean
# remove files which are updated by autoreconf:
	-rm aclocal.m4 configure

override_dh_auto_configure:
	-autoreconf -vfi
	./configure --build $(DEB_HOST_GNU_TYPE) \
		--docdir=/usr/share/doc/gle-graphics/ \
		--with-rpath=no --with-scripts=no \
		$(CONFIGURE_LIBS)

override_dh_auto_install:
	dh_auto_install
	cp debian/qgle.1 debian/gle-graphics/usr/share/man/man1/
	cp debian/manip.1 debian/gle-graphics/usr/share/man/man1/
# do not ship helper that is only used during build
	[ ! -f debian/gle-graphics/usr/bin/glebtool ] || rm debian/gle-graphics/usr/bin/glebtool

# do not compress LICENSE.txt as it needs to be read by qgle
# qgle can now read compressed files
#override_dh_compress:
#	dh_compress -X usr/share/doc/gle-graphics/LICENSE.txt

=== debian/watch ===
version=3
http://sf.net/glx/(?i:gle)[_-](.+)\.(.+)\.(.+)[_-]src\.zip

## gle-graphics 4.2.5

=== debian/changelog ===
gle-graphics (4.2.5-7) UNRELEASED; urgency=medium

  * fix FTBS using patch from Slávek Banko (closes: #853420)
  * update Standards-Version to 4.1.1 (no changes)

 -- Christian T. Steigies <cts@debian.org>  Sun, 29 Oct 2017 20:57:49 +0100

gle-graphics (4.2.5-6) unstable; urgency=medium

  * add patch from Reiner Herrmann to initialize font table
  * point Vcs-Git and Vcs-Browser to the same recommended location
  * Update configure.ac to prevent autoheader from failing
  * fix spelling mistakes found by codespell 
  * remove typo-occured patch (included in codespell) and refresh patches
  * update manpages, use a manpages file

 -- Christian T. Steigies <cts@debian.org>  Thu, 07 Jul 2016 18:45:11 +0200

gle-graphics (4.2.5-5) unstable; urgency=medium

  * Team upload.
  * Apply patch from Reiner Herrmann to fix reproducible build fix to not
    require faketime.  Closes: #821766
  * Bump Standards-Version to 3.9.8, no changes needed.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 23 Apr 2016 11:56:53 +0000

gle-graphics (4.2.5-4) unstable; urgency=medium

  * use faketime to build gle-manual PDF files reproducibly

 -- Christian T. Steigies <cts@debian.org>  Tue, 29 Mar 2016 11:48:58 +0200

gle-graphics (4.2.5-3) unstable; urgency=medium

  * replace today in manual with SOURCE_DATE to build reproducibly
  * update watch file
  * fix typo: occurred
  * use secure URIs in Vcs fields

 -- Christian T. Steigies <cts@debian.org>  Sat, 26 Mar 2016 14:04:07 +0100

gle-graphics (4.2.5-2) unstable; urgency=medium

  * build reproducibly by passing SOURCE_DATE_EPOCH to build
  * updated Standards-Version to 3.9.7 (no changes)
  * set Maintainer to Debian Science Maintainers and add myself to Uploaders
  * added Vcs fields

 -- Christian T. Steigies <cts@debian.org>  Sun, 20 Mar 2016 17:07:38 +0100

gle-graphics (4.2.5-1) unstable; urgency=medium

  * new upstream version
  * remove gle.cpp-typo patch

 -- Christian T. Steigies <cts@debian.org>  Tue, 18 Aug 2015 11:55:12 +0200

gle-graphics (4.2.4c-6) unstable; urgency=low

  * update config.{sub,guess} with autools_dev (closes: #727871, #744438)
  * updated Standards-Version to 3.9.6 (no changes)
  * use debhelper 9 and dpkg-buildflags instead of hardening-wrapper,
    enable hardening on sparc
  * patch qgle.pro.in so that LDFLAGS are used (for hardening)

 -- Christian T. Steigies <cts@debian.org>  Tue, 21 Oct 2014 21:59:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,13 @@
 Source: gle-graphics
 Section: graphics
 Priority: optional
-Maintainer: Christian T. Steigies <cts@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Christian T. Steigies <cts@debian.org>
 Build-Depends: automake,
-               debhelper (>= 8.0.0),
+               autotools-dev,
+               debhelper (>= 9),
+               dh-autoreconf,
                ghostscript,
-               hardening-wrapper,
                libboost-dev,
                libcairo-dev,
                libjpeg-dev,
@@ -19,13 +21,15 @@
                pkg-config,
                texlive,
                texlive-latex-extra
-Standards-Version: 3.9.3
+Standards-Version: 4.1.1
 Homepage: http://glx.sf.net
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/gle-graphics.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/gle-graphics.git
 
 Package: gle-graphics
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Recommends: libgs9
+Recommends: libgs9, gle-graphics-doc
 Description: Graphics Layout Engine
  GLE is a graphics scripting language designed for creating publication
  quality figures such as charts, plots, graphs, and diagrams. It

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# fix build problems on the hurd
ifeq ($(DEB_HOST_ARCH),hurd-i386)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -Wl,-lpthread -Wl,--as-needed -fPIC
endif

# get source date in seconds since 1970 and pass it to the build
SOURCE_DATE_EPOCH=$(shell date -d "$$(dpkg-parsechangelog --count 1 -SDate)" +%s)
export DEB_CPPFLAGS_MAINT_APPEND = -DDEBIAN_EPOCH=$(SOURCE_DATE_EPOCH)

# source date string instead of \today in gle-manual
# use only digits, locale month is not reproducible
DATE_FMT = %Y-%m-%d
SOURCE_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)"  2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")

%:
	dh $@ --with autotools_dev,autoreconf

override_dh_auto_build:
	dh_auto_build
	echo $(SOURCE_DATE) > gle-refman/title/source_date.tex
	make doc

override_dh_auto_clean:
	dh_auto_clean
# remove source_date for manual:
	[ ! -f gle-refman/title/source_date.tex ] || rm  gle-refman/title/source_date.tex

override_dh_auto_configure:
	dh_auto_configure -- --with-rpath=no

override_dh_auto_install:
	dh_auto_install
# do not ship helper that is only used during build
	[ ! -f debian/gle-graphics/usr/bin/glebtool ] || rm debian/gle-graphics/usr/bin/glebtool

# manpages are updated only when needed, call this target manually
manpage:
	docbook-to-man debian/manip.sgml > debian/manip.1
	docbook-to-man debian/qgle.sgml > debian/qgle.1

=== debian/watch ===
version=3
http://sf.net/glx/gle-graphics-([\d\.]+)-src\.tar\.gz

## gle-graphics 4.3.3

=== debian/changelog ===
gle-graphics (4.3.3-3) unstable; urgency=medium

  * update watch file
  * enable building on the hurd
  * drop build-depends on texlive, this is only used by the manual,
    which is now built as a separate package

 -- Christian T. Steigies <cts@debian.org>  Sat, 14 Jan 2023 17:09:14 +0100

gle-graphics (4.3.3-2) unstable; urgency=medium

  * create inittex.ini during build
  * remove deprecated register keyword
  * upload to unstable

 -- Christian T. Steigies <cts@debian.org>  Thu, 05 Jan 2023 17:36:47 +0100

gle-graphics (4.3.3-1) experimental; urgency=medium

  * new upstream version
  * remove throw(ParserError) from functions and variables (closes: #984153)
  * user larger arrays in makefmt/makefmt.cpp
  * hardcode GLE_TOP_DIR to /usr/share/gle-graphics
  * new glebtool binary package for building the manual, add a manpage
  * PDF manual is now in separate gle-graphics-manual package
  * GLE includes and examples are in separate gle-graphics-library package
  * update Standards-Version to 4.6.2 (no changes)

 -- Christian T. Steigies <cts@debian.org>  Sat, 31 Dec 2022 14:30:55 +0100

gle-graphics (4.3.2-1) UNRELEASED; urgency=low

  * new upstream version

 -- Christian T. Steigies <cts@debian.org>  Mon, 7 Mar 2022 20:53:09 -0500 

gle-graphics (4.3.1-1) UNRELEASED; urgency=low

  * new upstream version

 -- Christian T. Steigies <cts@debian.org>  Mon, 31 Jan 2022 19:22:24 -0500

gle-graphics (4.3.0-1) UNRELEASED; urgency=low

  * new upstream version, uses cmake instead of autotools
  * use FindCairo.cmake and FindPixman.cairo from freerdp2 package

 -- Christian T. Steigies <cts@debian.org>  Fri, 27 Aug 2021 21:42:32 +0200

gle-graphics (4.2.5-8) unstable; urgency=medium

  * port qgle to Qt5 (closes: #874901, #935913)
  * add qt5-libgs-multiarch patch (closes: #935720)
  * update Standards-Version to 4.5.0 (no changes)

 -- Christian T. Steigies <cts@debian.org>  Mon, 09 Mar 2020 13:10:16 +0100

gle-graphics (4.2.5-7) unstable; urgency=medium

  * fix FTBS using patch from Slávek Banko (closes: #853420)
  * update Standards-Version to 4.1.1 (no changes)

 -- Christian T. Steigies <cts@debian.org>  Sun, 29 Oct 2017 20:57:49 +0100

=== debian/control ===
Source: gle-graphics
Section: graphics
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christian T. Steigies <cts@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               freeglut3-dev,
               ghostscript,
               libboost-dev,
               libcairo-dev,
               libgs-dev,
               libjpeg-dev,
               libpng-dev,
               libpoppler-glib-dev,
               qtbase5-dev,
               libqt5opengl5-dev,
               libtiff-dev,
               libtool,
               ncurses-dev,
               pkg-config
Standards-Version: 4.6.2
Homepage: http://glx.sf.net
Vcs-Browser: https://salsa.debian.org/science-team/gle-graphics
Vcs-Git: https://salsa.debian.org/science-team/gle-graphics.git

Package: gle-graphics
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libgs9, gle-graphics-manual
Description: Graphics Layout Engine
 GLE is a graphics scripting language designed for creating publication
 quality figures such as charts, plots, graphs, and diagrams. It
 supports various chart types (including function plot, histogram, bar
 chart, scatter plot, contour plot, color map, and surface plot) through
 a simple but flexible set of graphing commands; more complex output can
 be created by relying on its scripting language, which is full featured
 with subroutines, variables, and logic control.
 .
 GLE relies on LaTeX for text output and supports mathematical formulae
 in graphs and figures. Output formats include (E)PS, PDF, JPEG, and PNG.

Package: gle-graphics-glebtool
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, gle-graphics (>= ${source:Version}) 
Description: Graphics Layout Engine glebtool
 glebtool is used to build the PDF gle-graphics-manual

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    export DH_VERBOSE = 1
endif
### testing
export DH_VERBOSE = 1
###

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

empty :=

#DEB_CMAKE_EXTRA_FLAGS = \
#    -DGLE_TOP_DIR=/usr/share/gle-graphics/$(DEB_VERSION_UPSTREAM) \
#    -CMAKE_INSTALL_PREFIX=/usr/share/gle-graphics/4.3.3 \
#    $(empty)

# fix build problems on the hurd
ifeq ($(DEB_HOST_ARCH),hurd-i386)
    export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -Wl,-lpthread -Wl,--as-needed -fPIC
endif

# enable debugging
#export DEB_CPPFLAGS_MAINT_APPEND = -g
export DEB_CFLAGS_MAINT_APPEND = -g

# define libgs search path used by qgle
HEAD = /usr/lib/
LIBGS := $(HEAD)$(DEB_HOST_MULTIARCH)

# source date string instead of \today in gle-manual
# use only digits, locale month is not reproducible
DATE_FMT = %Y-%m-%d
SOURCE_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)"  2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
# https://reproducible-builds.org/docs/source-date-epoch/
export SOURCE_DATE_EPOCH ?= $(shell dpkg-parsechangelog -STimestamp)

%:
	dh $@

override_dh_auto_build:
	#obsolete? echo "const char *debian_lib = \""$(LIBGS)"\";" > src/gui/debian_gs.h
	dh_auto_build

	sed s/@GLE_VERSION@/$(DEB_VERSION_UPSTREAM)/ debian/gle.1.in | sed s/@GLE_INSTALL_DATA@/"\/usr\/share\/gle-graphics"/  > debian/gle.1

# manpages are updated only when needed, call this target manually
manpage:
	docbook-to-man debian/manip.sgml > debian/manip.1
	docbook-to-man debian/qgle.sgml > debian/qgle.1
	docbook-to-man debian/glebtool.sgml > debian/glebtool.1
